## RiskyMod
A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well. Nearly every change from this mod can be toggled on/off, so you can configure it to your liking!

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this.

Full change list can be found at https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority.

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

**Contact me if you're interested in translating the mod!**

## Main Features

- Oneshot Protection now actually works.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage stacking.
	- Most forms of range scaling have been removed, and most items aren't able to proc chain anymore.
- Big balance pass over all the Survivors
	- Less useless skill options, default Commando is good now!
- Drone performance now remains the same on all stages.

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

- Make Google Doc more readable/pretty.
	- Split up into multiple separate docs?
- Tweak enemy pools

*Mostly done with everything I've wanted to do with the mod. Plan going forward is to iron out the existing balance. There's some items that I don't like but don't have any ideas for reworking, so I'll list them here and leave it up to you on whether you want to enable them in your runs.*

- Items I don't like but don't want to touch either:
	- Roll of Pennies
	- Lost Seer's Lens 
	- Regenerating Scrap
	- Executive Card
	
## For Developers

To make custom allies compatible with RiskyMod's ally changes, use these items located in AllyItems.cs:

- AllyMarkerItem makes the holder benefit from Ally damage resistances. No effect when stacked.
- AllyScalingItem changes level scaling from +30% HP +20% damage -> +20% HP +30% damage so that allies perform the same on all stages. No effect when stacked.
- AllyRegenItem makes the holder's HP regenerate to full in X seconds, X being the amount of stacks.
- AllyAllowVoidDeathItem makes the holder to bypass the "No Void Death" config option.
- AllyAllowOverheatDeathItem makes the holder to bypass the "No Overheat" config option.
- AllyResistAoEItem enables the ResistantToAoE bodyflag on the holder, granting them +300 armor against attacks with DamageType.AoE

These are always initialized even if Ally changes are disabled and their effects have config-checking built-in, so you can simply add them to your allies without having to worry about anything.

Make sure these are only given to Player-team allies, since they'll be painful to fight against (in a bad/unintuitive way) when they're given to enemies.
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp Distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

Acrid Hitbox Tweaks - TheTimesweeper

Buff Icons - SOM, VALE-X

## Changelog

*Full changelog included in the .zip*

`0.16.1`

- Added config for AI Targetfinding in RiskyMod_Enemies.cfg

`0.16.0`

- Enemies
	- AI Targetfinding
		- Enabled FullVision flag and disabled LoS checks.
		
		*RoR2's AI targetfinding doesn't work well with its horde shooter gameplay. Enemies often go AFK in random parts of the map and take up spawnslots, and oftentimes they will forget what they're doing and go AFK mid-combat due to losing their target.*

- Items
	- Stickybomb
		- Disabled physics.

		*Bandaid fix for stickies falling off of flying enemies in MP.*

	- Shuriken
		- No longer procs Elemental Bands. 
		
		*For most characters, this item is an instant scrap due to how it steals Band procs.*

	- Razor Wire
		- Proc Coefficient no longer scales off of HP lost.
		- Proc Coefficient is now 0.5 for normal damage, 0.1 for DoT damage.

		*Simplifying this item's behavior since the proc coefficient thing is really only necessary for Helfire.*

	- Squid Polyp
		- Increased HP from 100% (+30%) -> 100% (+50%)

	- Unstable Tesla Coil
		- Increased radius from 20m -> 25m

		*New radius matches the radius used for most other lightning/AoE type effects.*

	- Shaped Glass
		- Logbook now lists the new stacking behavior.
		
	- Transcendence
		- No longer disables TrueOSP if ShieldGating AND Transcendence Always Shieldgate are disabled.

- Survivors

	- Made internal survivor modifaction code more robust.
		- SkillDefs are now modified by directly loading the Addressable, instead of searching the Character's SkillFamilies.
		- A lot of things got changed internally. Let me know if any skills are behaving weirdly!
	
	- Huntress
		- Flurry
			- Added extra code to be double sure that arrows aren't getting lost at high attack speeds.
		
	- Bandit
		- Stats
			- Reduced HP from 110 -> 100.
			
			*Bandit got a lot of buffs in this mod, with the extra dash from his knife, the invisibility position tracking buff, and more. Lower HP is more in line with his role of being a hit and run Assassin. This is the same HP value used for BanditReloaded.
			
		- Burst
			- Reduced proc coefficient from 0.75 -> 0.6
			
			*Closer to Vanilla, but still higher.*

		- Serrated Dagger
			- Fixed the attack getting delayed/cancelled by Smokebomb's animation.

		- Smokebomb
			- Increased cooldown from 6s -> 7s

			*This increases the effective cooldown from 3s -> 4s, which is the same as Commando's Roll.*
			
		- Special Grace Period
			- Now uses separate values for Host and Clients.
				- Host/Singleplayer: 0.5s
				- Multiplayer Client: 1.0s
				
			*0.5s was the original intended value for BanditReloaded, but it had to be increased due to problems with consistency for online clients.*

	- MUL-T
		- Fixed M2 changes applying to other mods that clone the projectile.

	- Engineer
		- Mobile Turrets
			- Now immune to fall damage.

			*These sometimes like to walk off cliffs because the AI isn't very smart.*
			
	- Artificer
		- Disabled Blaze Storm and Electrocute by default.
			- Only applies to new installs. Existing configs are unchanged.
			
			*These skills are made of reused assets and aren't polished at all. Since they won't be getting any work done on them, they'll be hidden by default.*
			
`0.15.0`

- Commando
	- Frag Grenades
		- Reverted to Vanilla, except that they explode on direct impact with enemies.
			- If the nade hits the world first, it will behave as it does in Vanilla.
		- Cookable nades can be re-added as a separate standalone skill with https://thunderstore.io/package/Gatorism/Commando_Grenade_Cooking/
			- Comes with a config as well!
		
		*Wanted to give the option to use vanilla-ish nades, since I feel cooking is a bit awkward with Commando's skill flow. I feel explode on impact trivializes Vanilla nades a bit, but that's preferable to being unable to use them against flying enemies.*